Billboard
Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10624 Accepted Submission(s): 4701
Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.
On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.
Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.
When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.
If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).
Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
Input
There are multiple cases (no more than 40 cases).
The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.
Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
Sample Input
Sample Output
题目大意:
给你一个高为H,宽为W的布告板,现在向上边贴广告。第i张广告高为1宽度为Wi,贴广告要满足要从高往低处贴,然后尽量在左边贴。求每张海报贴的高度。
思路:
因为每张广告的高度都为1,宽度不确定,所以我们可以将布告栏旋转90°,将高作为端点,W作为端点的值,建立一个线段树。因为1 < h<= 10^9 , 而1 <= n <= 200,000;所以当h >= n时将h = n即可。
建立线段树之后,每次向左子树寻找最大值比海报宽度大的点,插入海报,并输出端点号。
# include<stdio.h>
# include<iostream>
# include<algorithm>
using namespace std;
const int MAXN = 200010;
int MAX[MAXN<<2];
void pushup(int root)
{
MAX[root] = max(MAX[root<<1],MAX[root<<1|1]);
}
void build(int root,int L,int R,int w)
{
MAX[root] = w;
if(L==R)
{
return;
}
int mid = (L+R)>>1;
build(root<<1,L,mid,w);
build(root<<1|1,mid+1,R,w);
pushup(root);
}
int query(int root,int L,int R,int v)
{
if(L==R)
{
MAX[root] -= v;
return L;
}
int mid = (L+R)>>1;
int res;
if(MAX[root<<1] >= v)
res = query(root<<1,L,mid,v);
else
res = query(root<<1|1,mid+1,R,v);
pushup(root);
return res;
}
int main()
{
int w,h,n,a;
while(~scanf("%d%d%d",&h,&w,&n))
{
if(h > n)
h = n;
build(1,1,h,w);
while(n--)
{
scanf("%d", &a);
if(MAX[1] < a)
printf("-1\n");
else
printf("%d\n",query(1,1,h,a));
}
}
return 0;
}